#ifndef _CACHE_H_
#define _CACHE_H_

typedef struct {
	char server[40];
	char server2[40];
	char domain[40];
} domain_ctls;

typedef struct {
	int numservers;
	int last_check_time;
	domain_ctls controllers[10];
} domain_list;


/* typedef struct { */
/* 	char username[20]; */
/* 	char userpassword[40]; */
/* 	char userdomain[20]; */
/* 	int usertimeout; */
/* } user_cache_list; */

typedef struct pam_ucl
{
  char nt_user[22]; /* This is the NT username */
  char ux_user[22]; /* This is the UNIX equivalent */
  char password[40]; /* This is the password for the NT domain */
  char mx_domain[20]; /* This is the NT domain or default */
  char nt_domain[20]; /* this is the NT domain (no default) */
  char pdc_nbname[20]; /* This is the Netbios name of the NT PDC*/
  char bdc_nbname[20]; /* This is the Netbios name of the NT BDC */
  char pdc_hostname[20]; /* This is the IP address of the NT PDC */
  char bdc_hostname[20]; /* This is the IP Address of the NT BDC */
  long usertimeout; /* This is the cache timeout value */

  struct pam_ucl *next; /* Linked list theory */

} user_cache_list;


typedef struct 
{
  int number_of_cached_users;
  user_cache_list *head;
  user_cache_list *last;

  /*   user_cache_list users[100]; */
} user_list;

int Valid_MapUser(struct pam_ucl *user);

#define CACHE_OK 0
#define CACHE_ENOENT 1
#define CACHE_ETIME 2

#define CACHE_TIMEOUT 120

#endif
